@echo off

SETLOCAL

title Register PrintManager ...

:: Preconditions:

:: Sufficient user rights, especially for Windows Vista, already checked elsewhere

:: PrintManager files already copied here:
set PMPATH=%CommonProgramFiles%\Siemens\Energy\Printing

:: check if DotNetFramework is installed
REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\.NETFramework" >Nul
if errorlevel 1 (
	echo Error reading HKLM\SOFTWARE\Microsoft\.NETFramework
	goto ERROR_DOTNETFRAMEWORK_ERROR
)

:: detect path of DotNetFramework installation
:: delims is a TAB followed by a space
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\.NETFramework" /v InstallRoot') DO SET FRAMEWORKPATH=%%B

:: we need e.g. C:\WINNT\Microsoft.NET\Framework\v2.0.50727\RegAsm.exe 
:: to register PrintManager2
for /D %%i in (%FRAMEWORKPATH%v2"."*) do (
	set REGASM=%%i\RegAsm.exe 
	goto CONTINUE2
)
echo %FRAMEWORKPATH%v2.* not found
goto ERROR_DOTNETFRAMEWORK_ERROR

:CONTINUE2

:: register PrintManager2
echo ------
echo Registering PrintManager ...
echo.
%REGASM% "%PMPATH%\Siemens.Energy.Printing2.COM.dll" /Codebase 2>nul

:: Increment shared dll counters for all PrintManager files

call IncrementSharedCount.bat "%PMPATH%\de\Siemens.Energy.Printing2.resources.dll"
call IncrementSharedCount.bat "%PMPATH%\en\Siemens.Energy.Printing2.resources.dll"
call IncrementSharedCount.bat "%PMPATH%\es\Siemens.Energy.Printing2.resources.dll"
call IncrementSharedCount.bat "%PMPATH%\fr\Siemens.Energy.Printing2.resources.dll"
call IncrementSharedCount.bat "%PMPATH%\it\Siemens.Energy.Printing2.resources.dll"
call IncrementSharedCount.bat "%PMPATH%\ru\Siemens.Energy.Printing2.resources.dll"
call IncrementSharedCount.bat "%PMPATH%\tr\Siemens.Energy.Printing2.resources.dll"
call IncrementSharedCount.bat "%PMPATH%\zh-CN\Siemens.Energy.Printing2.resources.dll"

FOR %%f IN ("%PMPATH%\*.*") DO (
	call IncrementSharedCount.bat "%%f"
)

FOR %%f IN ("%PMPATH%\Pics\*.*") DO (
	call IncrementSharedCount.bat "%%f"
)

GOTO END1

:ERROR_DOTNETFRAMEWORK_ERROR
echo %VERSION% needs at least Microsoft .Net Framework 2.0
echo Please check your DotNetFramework installation. 
goto END1

:END1
echo End of RegisterPrintManager
:: pause
